package org.jeecg.modules.ctop.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.ctop.entity.ByteDanceBudgetTemplate;
import org.jeecg.modules.ctop.entity.ByteDanceCampaignTemplate;
import org.jeecg.modules.ctop.entity.BytedanceDeliveryTargetTemplate;
import org.jeecg.modules.ctop.entity.CTopOauthToken;
import org.jeecg.modules.ctop.service.IByteDanceBudgetTemplateService;
import org.jeecg.modules.ctop.service.IByteDanceCampaignTemplateService;
import org.jeecg.modules.ctop.service.IBytedanceDeliveryTargetTemplateService;
import org.jeecg.modules.ctop.service.ICTopOauthTokenService;
import org.jeecg.modules.system.entity.SysDictItem;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

@RestController
@RequestMapping("template")
public class ByteDanceTemplateController {
    /**
     * 预算与出价模板
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("budget/insert")
    public Map<String, Object> budgetTemplateInsert(@RequestBody ByteDanceBudgetTemplate template, HttpServletRequest req) {
        return budgetTemplateService.insertTemplate(template);
    }

    /**
     * 广告组模板
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("campaign/insert")
    public Map<String, Object> campaignTemplateInsert(@RequestBody ByteDanceCampaignTemplate template, HttpServletRequest req) {
        return campaignTemplateService.insertTemplate(template);
    }

    /**
     * 投放目标
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("deliverytarget/insert")
    public Map<String, Object> diliverytargetTemplateInsert(@RequestBody BytedanceDeliveryTargetTemplate template, HttpServletRequest req) {
        return deliveryTargetTemplateService.insertTemplate(template);
    }

    /**
     * 预算与出价模板
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("budget/list")
    public Result<IPage<ByteDanceBudgetTemplate>> budgetTemplateList(ByteDanceBudgetTemplate template, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
        return budgetTemplateService.getList(template, pageNo, pageSize, req);
    }

    /**
     * 广告组模板
     *
     * @return
     */
    @PostMapping("campaign/list")
    public Result<IPage<ByteDanceCampaignTemplate>> campaignTemplateList(ByteDanceCampaignTemplate template, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
        return campaignTemplateService.getList(template, pageNo, pageSize, req);
    }

    /**
     * 投放目标
     *
     * @param template
     * @param req
     * @return
     */
    @PostMapping("deliverytarget/list")
    public Result<IPage<BytedanceDeliveryTargetTemplate>> diliverytargetTemplateList(BytedanceDeliveryTargetTemplate template, @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo, @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize, HttpServletRequest req) {
        return deliveryTargetTemplateService.getList(template, pageNo, pageSize, req);
    }

    @Autowired
    private IByteDanceCampaignTemplateService campaignTemplateService;
    @Autowired
    private IByteDanceBudgetTemplateService budgetTemplateService;
    @Autowired
    private IBytedanceDeliveryTargetTemplateService deliveryTargetTemplateService;
    @Autowired
    private ICTopOauthTokenService tokenService;

}
